HDU3486-RMQ

来源:互联网 发布:淘宝上买羊肉 编辑:程序博客网 时间:2024/06/05 00:15

Interviewe

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 6766    Accepted Submission(s): 1606


Problem Description
YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.
YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is , which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.
YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?
 

Input
The input consists of multiple cases.
In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.
The input ends up with two negative numbers, which should not be processed as a case.
 

Output
For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.
 

Sample Input
11 3007 100 7 101 100 100 9 100 100 110 110-1 -1
 
Sample Output
3
Hint
We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6, and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.


题目大意:给你n个数,现在将n个数分成m组,每组的个数为n/m 求最小的m使得每组里面最大的数的和大于k,如果不存在就是输出-1

题目思路:求区间最大,如果暴力去求的话显然时间复杂度会非常大,所以我们就会想到用一种方法来预处理区间最值,所以就会想到RMQ-ST ,因为查询时的复杂度是O(1),所以当预处理玩区间最值后就可以去枚举组数,而在输入时可以求出总和和最大的数,如果总和都小于等于k就输出-1,如果最大值大于k就是1, 

否则就从max(2,k/max)开始枚举


AC代码:


#include<iostream>#include<stdio.h>#include<string.h>#include<cmath>#include<algorithm>#include<string>#include<vector>using namespace std;#define N 200005int M(int a,int b){    return a>b?a:b;}int n,m;int a[N];int dp[N][20];void RMQ(){   // int tmp=log((double)n)/log(2.0);    for (int i=1;i<=n;i++)    dp[i][0]=a[i];    for (int j=1;j<=log(n)/log(2);j++)    for (int i=1;i<=n;i++)    if (i+(1<<j)-1<=n)    dp[i][j]=M(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);}int getmax(int l,int r){    int k=log(r-l+1)/log(2.0);    return M(dp[l][k],dp[r-(1<<k)+1][k]);}int main(){   while(scanf("%d%d",&n,&m)){        if(n<0&&m<0)break;       int Max = 0,sum=0;       for(int i=1;i<=n;i++){            scanf("%d",&a[i]);            Max = M(Max,a[i]);            sum+=a[i];       }       if(Max>m){printf("1\n");continue;}       if(sum<=m){printf("-1\n");continue;}       int ans = M(2,m/Max); RMQ();       while(ans<n){         sum=0;         int x = n/ans;         for(int i=1;i<=ans;i++){            sum+=getmax((i-1)*x+1,i*x);         }         if(sum>m)break;         ans++;       }       printf("%d\n",ans);   }    return 0;}







0 0